ObjectMatrix2D (Colt 1.2.0 - API Specification)
Keywords: cern.colt.matrix.ObjectMatrix2D class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cern.colt.matrix
Class ObjectMatrix2D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix2D
                  cern.colt.matrix.ObjectMatrix2D

All Implemented Interfaces:
  Cloneable, Serializable

Direct Known Subclasses:
  DenseObjectMatrix2D, SparseObjectMatrix2D

public abstract class ObjectMatrix2D
extends AbstractMatrix2D

Abstract base class for 2-d matrices holding `Object` elements. First see the package summary and javadoc tree view to get the broad picture.

A matrix has a number of rows and columns, which are assigned upon instance construction - The matrix's size is then `rows()*columns()`. Elements are accessed via `[row,column]` coordinates. Legal coordinates range from `[0,0]` to `[rows()-1,columns()-1]`. Any attempt to access an element at a coordinate `column<0 || column>=columns() || row<0 || row>=rows()` will throw an `IndexOutOfBoundsException`.

Note that this implementation is not synchronized.

Version:
  1.0, 09/24/99
See Also:
  Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Method Summary
`Object` | `aggregate(ObjectMatrix2D other, ObjectObjectFunction aggr, ObjectObjectFunction f)` Applies a function to each corresponding cell of two matrices and aggregates the results.
`Object` | `aggregate(ObjectObjectFunction aggr, ObjectFunction f)` Applies a function to each cell and aggregates the results.
`ObjectMatrix2D` | `assign(Object value)` Sets all cells to the state specified by `value`.
`ObjectMatrix2D` | `assign(Object[][] values)` Sets all cells to the state specified by `values`.
`ObjectMatrix2D` | `assign(ObjectFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.
`ObjectMatrix2D` | `assign(ObjectMatrix2D other)` Replaces all cell values of the receiver with the values of another matrix.
`ObjectMatrix2D` | `assign(ObjectMatrix2D y, ObjectObjectFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.
`int` | `cardinality()` Returns the number of cells having non-zero values; ignores tolerance.
`ObjectMatrix2D` | `copy()` Constructs and returns a deep copy of the receiver.
`boolean` | `equals(Object otherObj)` Compares the specified Object with the receiver for equality.
`boolean` | `equals(Object otherObj, boolean testForEquality)` Compares the specified Object with the receiver for equality.
`Object` | `get(int row, int column)` Returns the matrix cell value at coordinate `[row,column]`.
`void` | `getNonZeros(IntArrayList rowList, IntArrayList columnList, ObjectArrayList valueList)` Fills the coordinates and values of cells having non-zero values into the specified lists.
`abstract Object` | `getQuick(int row, int column)` Returns the matrix cell value at coordinate `[row,column]`.
`ObjectMatrix2D` | `like()` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the same number of rows and columns.
`abstract ObjectMatrix2D` | `like(int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns.
`abstract ObjectMatrix1D` | `like1D(int size)` Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver.
`void` | `set(int row, int column, Object value)` Sets the matrix cell at coordinate `[row,column]` to the specified value.
`abstract void` | `setQuick(int row, int column, Object value)` Sets the matrix cell at coordinate `[row,column]` to the specified value.
`Object[][]` | `toArray()` Constructs and returns a 2-dimensional array containing the cell values.
`String` | `toString()` Returns a string representation using default formatting.
`ObjectMatrix1D` | `viewColumn(int column)` Constructs and returns a new slice view representing the rows of the given column.
`ObjectMatrix2D` | `viewColumnFlip()` Constructs and returns a new flip view along the column axis.
`ObjectMatrix2D` | `viewDice()` Constructs and returns a new dice (transposition) view; Swaps axes; example: 3 x 4 matrix --> 4 x 3 matrix.
`ObjectMatrix2D` | `viewPart(int row, int column, int height, int width)` Constructs and returns a new sub-range view that is a `height x width` sub matrix starting at `[row,column]`.
`ObjectMatrix1D` | `viewRow(int row)` Constructs and returns a new slice view representing the columns of the given row.
`ObjectMatrix2D` | `viewRowFlip()` Constructs and returns a new flip view along the row axis.
`ObjectMatrix2D` | `viewSelection(int[] rowIndexes, int[] columnIndexes)` Constructs and returns a new selection view that is a matrix holding the indicated cells.
`ObjectMatrix2D` | `viewSelection(ObjectMatrix1DProcedure condition)` Constructs and returns a new selection view that is a matrix holding all rows matching the given condition.
`ObjectMatrix2D` | `viewSorted(int column)` Sorts the matrix rows into ascending order, according to the natural ordering of the matrix values in the given column.
`ObjectMatrix2D` | `viewStrides(int rowStride, int columnStride)` Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell.

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix2D
`checkShape, checkShape, columns, rows, size, toStringShort`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix
`ensureCapacity, trimToSize`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### aggregate

    public Object aggregate(ObjectObjectFunction aggr,
                            ObjectFunction f)

  Applies a function to each cell and aggregates the results. Returns a value `v` such that `v==a(size())` where `a(i) == aggr( a(i-1), f(get(row,column)) )` and terminators are `a(1) == f(get(0,0)), a(0)==null`.

  Example:

      cern.jet.math.Functions F = cern.jet.math.Functions.functions;
      2 x 2 matrix
      0 1
      2 3

      // Sum( x[row,col]*x[row,col] )
      matrix.aggregate(F.plus,F.square);
      --> 14

  For further examples, see the package doc.

  Parameters:
    `aggr` - an aggregation function taking as first argument the current aggregation and as second argument the transformed current cell value.
    `f` - a function transforming the current cell value.
  Returns:
    the aggregated measure.
  See Also:
    `Functions`

### aggregate

    public Object aggregate(ObjectMatrix2D other,
                            ObjectObjectFunction aggr,
                            ObjectObjectFunction f)

  Applies a function to each corresponding cell of two matrices and aggregates the results. Returns a value `v` such that `v==a(size())` where `a(i) == aggr( a(i-1), f(get(row,column),other.get(row,column)) )` and terminators are `a(1) == f(get(0,0),other.get(0,0)), a(0)==null`.

  Example:

      cern.jet.math.Functions F = cern.jet.math.Functions.functions;
      x == 2 x 2 matrix
      0 1
      2 3

      y == 2 x 2 matrix
      0 1
      2 3

      // Sum( x[row,col] * y[row,col] )
      x.aggregate(y, F.plus, F.mult);
      --> 14

      // Sum( (x[row,col] + y[row,col])^2 )
      x.aggregate(y, F.plus, F.chain(F.square,F.plus));
      --> 56

  For further examples, see the package doc.

  Parameters:
    `aggr` - an aggregation function taking as first argument the current aggregation and as second argument the transformed current cell values.
    `f` - a function transforming the current cell values.
  Returns:
    the aggregated measure.
  Throws:
    `IllegalArgumentException` - if `columns() != other.columns() || rows() != other.rows()`
  See Also:
    `Functions`

### assign

    public ObjectMatrix2D assign(Object[][] values)

  Sets all cells to the state specified by `values`. `values` is required to have the form `values[row][column]` and have exactly the same number of rows and columns as the receiver.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

  Parameters:
    `values` - the values to be filled into the cells.
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `values.length != rows() || for any 0 <= row < rows(): values[row].length != columns()`.

### assign

    public ObjectMatrix2D assign(ObjectFunction function)

  Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.

  Example:

      matrix = 2 x 2 matrix
      0.5 1.5
      2.5 3.5

      // change each cell to its sine
      matrix.assign(cern.jet.math.Functions.sin);
      -->
      2 x 2 matrix
      0.479426  0.997495
      0.598472 -0.350783

  For further examples, see the package doc.

  Parameters:
    `function` - a function object taking as argument the current cell's value.
  Returns:
    `this` (for convenience only).
  See Also:
    `Functions`

### assign

    public ObjectMatrix2D assign(ObjectMatrix2D other)

  Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same number of rows and columns. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.

  Parameters:
    `other` - the source matrix to copy from (may be identical to the receiver).
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `columns() != other.columns() || rows() != other.rows()`

### assign

    public ObjectMatrix2D assign(ObjectMatrix2D y,
                                 ObjectObjectFunction function)

  Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.

  Example:

      // assign x[row,col] = x[row,col]y[row,col]
      m1 = 2 x 2 matrix
      0 1
      2 3

      m2 = 2 x 2 matrix
      0 2
      4 6

      m1.assign(m2, cern.jet.math.Functions.pow);
      -->
      m1 == 2 x 2 matrix
       1   1
      16 729

  For further examples, see the package doc.

  Parameters:
    `y` - the secondary matrix to operate on.
    `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `columns() != other.columns() || rows() != other.rows()`
  See Also:
    `Functions`

### assign

    public ObjectMatrix2D assign(Object value)

  Sets all cells to the state specified by `value`.

  Parameters:
    `value` - the value to be filled into the cells.
  Returns:
    `this` (for convenience only).

### cardinality

    public int cardinality()

  Returns the number of cells having non-zero values; ignores tolerance.

### copy

    public ObjectMatrix2D copy()

  Constructs and returns a deep copy of the receiver.

  Note that the returned matrix is an independent deep copy. The returned matrix is not backed by this matrix, so changes in the returned matrix are not reflected in this matrix, and vice-versa.

  Returns:
    a deep copy of the receiver.

### equals

    public boolean equals(Object otherObj)

  Compares the specified Object with the receiver for equality. Equivalent to `equals(otherObj,true)`.

  Parameters:
    `otherObj` - the Object to be compared for equality with the receiver.
  Returns:
    true if the specified Object is equal to the receiver.

### equals

    public boolean equals(Object otherObj,
                          boolean testForEquality)

  Compares the specified Object with the receiver for equality. Returns true if and only if the specified Object is also at least an ObjectMatrix2D, both matrices have the same size, and all corresponding pairs of cells in the two matrices are the same. In other words, two matrices are defined to be equal if they contain the same cell values in the same order. Tests elements for equality or identity as specified by `testForEquality`. When testing for equality, two elements `e1` and `e2` are equal if `(e1==null ? e2==null : e1.equals(e2))`.)

  Parameters:
    `otherObj` - the Object to be compared for equality with the receiver.
    `testForEquality` - if true -> tests for equality, otherwise for identity.
  Returns:
    true if the specified Object is equal to the receiver.

### get

    public Object get(int row,
                      int column)

  Returns the matrix cell value at coordinate `[row,column]`.

  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value of the specified cell.
  Throws:
    `IndexOutOfBoundsException` - if `column<0 || column>=columns() || row<0 || row>=rows()`

### getNonZeros

    public void getNonZeros(IntArrayList rowList,
                            IntArrayList columnList,
                            ObjectArrayList valueList)

  Fills the coordinates and values of cells having non-zero values into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists all have a new size, the number of non-zero values.

  In general, fill order is unspecified. This implementation fills like `for (row = 0..rows-1) for (column = 0..columns-1) do ...` . However, subclasses are free to us any other order, even an order that may change over time as cell values are changed. (Of course, result lists indexes are guaranteed to correspond to the same cell).

  Example:

      2 x 3 matrix:
      0, 0, 8
      0, 7, 0
      -->
      rowList    = (0,1)
      columnList = (2,1)
      valueList  = (8,7)

  In other words, `get(0,2)==8, get(1,1)==7`.

  Parameters:
    `rowList` - the list to be filled with row indexes, can have any size.
    `columnList` - the list to be filled with column indexes, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### getQuick

    public abstract Object getQuick(int row,
                                    int column)

  Returns the matrix cell value at coordinate `[row,column]`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value at the specified coordinate.

### like

    public ObjectMatrix2D like()

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the same number of rows and columns. For example, if the receiver is an instance of type `DenseObjectMatrix2D` the new matrix must also be of type `DenseObjectMatrix2D`, if the receiver is an instance of type `SparseObjectMatrix2D` the new matrix must also be of type `SparseObjectMatrix2D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Returns:
    a new empty matrix of the same dynamic type.

### like

    public abstract ObjectMatrix2D like(int rows,
                                        int columns)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns. For example, if the receiver is an instance of type `DenseObjectMatrix2D` the new matrix must also be of type `DenseObjectMatrix2D`, if the receiver is an instance of type `SparseObjectMatrix2D` the new matrix must also be of type `SparseObjectMatrix2D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### like1D

    public abstract ObjectMatrix1D like1D(int size)

  Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver. For example, if the receiver is an instance of type `DenseObjectMatrix2D` the new matrix must be of type `DenseObjectMatrix1D`, if the receiver is an instance of type `SparseObjectMatrix2D` the new matrix must be of type `SparseObjectMatrix1D`, etc.

  Parameters:
    `size` - the number of cells the matrix shall have.
  Returns:
    a new matrix of the corresponding dynamic type.

### set

    public void set(int row,
                    int column,
                    Object value)

  Sets the matrix cell at coordinate `[row,column]` to the specified value.

  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.
  Throws:
    `IndexOutOfBoundsException` - if `column<0 || column>=columns() || row<0 || row>=rows()`

### setQuick

    public abstract void setQuick(int row,
                                  int column,
                                  Object value)

  Sets the matrix cell at coordinate `[row,column]` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.

### toArray

    public Object[][] toArray()

  Constructs and returns a 2-dimensional array containing the cell values. The returned array `values` has the form `values[row][column]` and has the same number of rows and columns as the receiver.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

  Returns:
    an array filled with the values of the cells.

### toString

    public String toString()

  Returns a string representation using default formatting.

  See Also:
    `Formatter`

### viewColumn

    public ObjectMatrix1D viewColumn(int column)

  Constructs and returns a new slice view representing the rows of the given column. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa. To obtain a slice view on subranges, construct a sub-ranging view (`viewPart(...)`), then apply this method to the sub-range view.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | viewColumn(0) ==> | Matrix1D of size 2: 1, 4

  Parameters:
    `column` - the column to fix.
  Returns:
    a new slice view.
  Throws:
    `IndexOutOfBoundsException` - if `column < 0 || column >= columns()`.
  See Also:
    `viewRow(int)`

### viewColumnFlip

    public ObjectMatrix2D viewColumnFlip()

  Constructs and returns a new flip view along the column axis. What used to be column `0` is now column `columns()-1`, ..., what used to be column `columns()-1` is now column `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | columnFlip ==> | 2 x 3 matrix: 3, 2, 1 6, 5, 4 | columnFlip ==> | 2 x 3 matrix: 1, 2, 3 4, 5, 6

  Returns:
    a new flip view.
  See Also:
    `viewRowFlip()`

### viewDice

    public ObjectMatrix2D viewDice()

  Constructs and returns a new dice (transposition) view; Swaps axes; example: 3 x 4 matrix --> 4 x 3 matrix. The view has both dimensions exchanged; what used to be columns become rows, what used to be rows become columns. In other words: `view.get(row,column)==this.get(column,row)`. This is a zero-copy transposition, taking O(1), i.e. constant time. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa. Use idioms like `result = viewDice(A).copy()` to generate an independent transposed matrix.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | transpose ==> | 3 x 2 matrix: 1, 4 2, 5 3, 6 | transpose ==> | 2 x 3 matrix: 1, 2, 3 4, 5, 6

  Returns:
    a new dice view.

### viewPart

    public ObjectMatrix2D viewPart(int row,
                                   int column,
                                   int height,
                                   int width)

  Constructs and returns a new sub-range view that is a `height x width` sub matrix starting at `[row,column]`. Operations on the returned view can only be applied to the restricted range. Any attempt to access coordinates not contained in the view will throw an `IndexOutOfBoundsException`.

  Note that the view is really just a range restriction: The returned matrix is backed by this matrix, so changes in the returned matrix are reflected in this matrix, and vice-versa.

  The view contains the cells from `[row,column]` to `[row+height-1,column+width-1]`, all inclusive. and has `view.rows() == height; view.columns() == width;`. A view's legal coordinates are again zero based, as usual. In other words, legal coordinates of the view range from `[0,0]` to `[view.rows()-1==height-1,view.columns()-1==width-1]`. As usual, any attempt to access a cell at a coordinate `column<0 || column>=view.columns() || row<0 || row>=view.rows()` will throw an `IndexOutOfBoundsException`.

  Parameters:
    `row` - The index of the row-coordinate.
    `column` - The index of the column-coordinate.
    `height` - The height of the box.
    `width` - The width of the box.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `column<0 || width<0 || column+width>columns() || row<0 || height<0 || row+height>rows()`

### viewRow

    public ObjectMatrix1D viewRow(int row)

  Constructs and returns a new slice view representing the columns of the given row. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa. To obtain a slice view on subranges, construct a sub-ranging view (`viewPart(...)`), then apply this method to the sub-range view.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | viewRow(0) ==> | Matrix1D of size 3: 1, 2, 3

  Parameters:
    `row` - the row to fix.
  Returns:
    a new slice view.
  Throws:
    `IndexOutOfBoundsException` - if `row < 0 || row >= rows()`.
  See Also:
    `viewColumn(int)`

### viewRowFlip

    public ObjectMatrix2D viewRowFlip()

  Constructs and returns a new flip view along the row axis. What used to be row `0` is now row `rows()-1`, ..., what used to be row `rows()-1` is now row `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | rowFlip ==> | 2 x 3 matrix: 4, 5, 6 1, 2, 3 | rowFlip ==> | 2 x 3 matrix: 1, 2, 3 4, 5, 6

  Returns:
    a new flip view.
  See Also:
    `viewColumnFlip()`

### viewSelection

    public ObjectMatrix2D viewSelection(int[] rowIndexes,
                                        int[] columnIndexes)

  Constructs and returns a new selection view that is a matrix holding the indicated cells. There holds `view.rows() == rowIndexes.length, view.columns() == columnIndexes.length` and `view.get(i,j) == this.get(rowIndexes[i],columnIndexes[j])`. Indexes can occur multiple times and can be in arbitrary order.

  Example:

      this = 2 x 3 matrix:
      1, 2, 3
      4, 5, 6
      rowIndexes     = (0,1)
      columnIndexes  = (1,0,1,0)
      -->
      view = 2 x 4 matrix:
      2, 1, 2, 1
      5, 4, 5, 4

  Note that modifying the index arguments after this call has returned has no effect on the view. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  To indicate "all" rows or "all columns", simply set the respective parameter

  Parameters:
    `rowIndexes` - The rows of the cells that shall be visible in the new view. To indicate that all rows shall be visible, simply set this parameter to `null`.
    `columnIndexes` - The columns of the cells that shall be visible in the new view. To indicate that all columns shall be visible, simply set this parameter to `null`.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `!(0 <= rowIndexes[i] < rows())` for any `i=0..rowIndexes.length()-1`.
    `IndexOutOfBoundsException` - if `!(0 <= columnIndexes[i] < columns())` for any `i=0..columnIndexes.length()-1`.

### viewSelection

    public ObjectMatrix2D viewSelection(ObjectMatrix1DProcedure condition)

  Constructs and returns a new selection view that is a matrix holding all rows matching the given condition. Applies the condition to each row and takes only those row where `condition.apply(viewRow(i))` yields `true`. To match columns, use a dice view.

  Example:

      // extract and view all rows which have a value < threshold in the first column (representing "age")
      final Object threshold = 16;
      matrix.viewSelection(
         new ObjectMatrix1DProcedure() {
            public final boolean apply(ObjectMatrix1D m) { return m.get(0) < threshold; }
         }
      );

      // extract and view all rows with RMS < threshold
      // The RMS (Root-Mean-Square) is a measure of the average "size" of the elements of a data sequence.
      matrix = 0 1 2 3
      final Object threshold = 0.5;
      matrix.viewSelection(
         new ObjectMatrix1DProcedure() {
            public final boolean apply(ObjectMatrix1D m) { return Math.sqrt(m.aggregate(F.plus,F.square) / m.size()) < threshold; }
         }
      );

  For further examples, see the package doc. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `condition` - The condition to be matched.
  Returns:
    the new view.

### viewSorted

    public ObjectMatrix2D viewSorted(int column)

  Sorts the matrix rows into ascending order, according to the natural ordering of the matrix values in the given column. This sort is guaranteed to be stable. For further information, see `Sorting.sort(ObjectMatrix2D,int)`. For more advanced sorting functionality, see `Sorting`.

  Returns:
    a new sorted vector (matrix) view.
  Throws:
    `IndexOutOfBoundsException` - if `column < 0 || column >= columns()`.

### viewStrides

    public ObjectMatrix2D viewStrides(int rowStride,
                                      int columnStride)

  Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell. More specifically, the view has `this.rows()/rowStride` rows and `this.columns()/columnStride` columns holding cells `this.get(i*rowStride,j*columnStride)` for all `i = 0..rows()/rowStride - 1, j = 0..columns()/columnStride - 1`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `rowStride` - the row step factor.
    `columnStride` - the column step factor.
  Returns:
    a new view.
  Throws:
    `IndexOutOfBoundsException` - if `rowStride<=0 || columnStride<=0`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jump to the Colt Homepage